clear all;
close all;
% Define constants
Tf = 1;     % Final time
Tobs = 1;   % Observation time
a = 0;      % Left endpoint
b = 1;      % Right endpoint
Nt = 400;   % # of intervals in the t - direction
Nx =  20;   % # of intervals in the x - direction
%
h = (b-a) / Nx;
tau = Tf / Nt;
Ntobs = round(Tobs/tau) + 1;
% Calculate the Courant number mu;
mu = tau / (h*h)
mu2 = 1 + 2 * mu;
% Initialize 
t = linspace(0,Tf,Nt+1);
x = linspace(a,b,Nx+1);
U = zeros(Nt+1,Nx+1);
%
U(1,:) = u0(x);
%ua = 0; ub = 0;
%
% Coefficients of the tridiagonal matrix
%
a = mu2  * ones(Nx-1);
b =  -mu * ones(Nx-2);
%
% Perform the Cholesky decomposition
%
[d,c] = choltridLU(a,b);
%
% Loop over the time steps
for m = 2 : Nt+1
    f = [U(m-1,2:Nx)]';
    U(m,2:Nx) = choltridSolve(d,c,f);
end
uex = exact(t(Ntobs),x);
uap = U(Ntobs,:);
plot(x,uex,'-o',x,uap,'r-*');
legend('exact','approximate');
title(['Backward f.d. for u_t = u_{xx}. Time t = ' num2str(t(Ntobs))],'FontSize',16);
xlabel('x');
grid on;
err = norm(uex-uap)/norm(uex)
% tt = [0 0.1 0.2 0.3]
% nt = round(tt/tau) + 1
% figure
% for i = 1:length(tt)
%     uappr = U(nt(i),:);
%     plot(x,uappr)
%     hold on
% end
